diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java
index 20a4154d8..5777f456f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java
@@ -2,7 +2,6 @@ package net.minecraft.client.render.particle;
 
 
 import net.minecraft.client.render.tessellator.TessellatorParticle;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
@@ -51,12 +50,7 @@ public class ParticleSnowShovel extends Particle {
         if (this.age++ >= this.lifetime) {
             this.remove();
         }
-        int val = (7 - ((this.age * 8) / this.lifetime));
-        if (val >= 0) {
-            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
-        } else {
-            this.tex = null;
-        }
+        this.tex = ParticleTextureCache.getPuffStage(this.age, this.lifetime);
         this.yd -= 0.03D;
         this.move(this.xd, this.yd, this.zd);
         this.xd *= 0.99D;
@@ -67,5 +61,4 @@ public class ParticleSnowShovel extends Particle {
             this.zd *= 0.7D;
         }
     }
-
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleTextureCache.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleTextureCache.java
new file mode 100644
index 000000000..412ba1073
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleTextureCache.java
@@ -0,0 +1,52 @@
+package net.minecraft.client.render.particle;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class ParticleTextureCache {
+    // Statically prefetch icons to avoid the cost of dynamically fetching them at runtime
+    public static final @NotNull IconCoordinate @NotNull [] ICON_PUFF_STAGES = new IconCoordinate[] {
+            TextureRegistry.getTexture("minecraft:particle/puff_0"),
+            TextureRegistry.getTexture("minecraft:particle/puff_1"),
+            TextureRegistry.getTexture("minecraft:particle/puff_2"),
+            TextureRegistry.getTexture("minecraft:particle/puff_3"),
+            TextureRegistry.getTexture("minecraft:particle/puff_4"),
+            TextureRegistry.getTexture("minecraft:particle/puff_5"),
+            TextureRegistry.getTexture("minecraft:particle/puff_6"),
+            TextureRegistry.getTexture("minecraft:particle/puff_7"),
+    };
+
+    public static @Nullable IconCoordinate getPuffStage(int age, int lifetime) {
+        if (age < 0) return ICON_PUFF_STAGES[ICON_PUFF_STAGES.length - 1];
+        if (age > lifetime) return null;
+        final int maxIndex = ICON_PUFF_STAGES.length - 1;
+        int val = (maxIndex - ((age * maxIndex) / lifetime));
+        return ICON_PUFF_STAGES[val];
+    }
+
+    public static final @NotNull IconCoordinate @NotNull [] ICON_SPLASH_RAIN = new IconCoordinate[] {
+            TextureRegistry.getTexture("minecraft:particle/splash_rain_0"),
+            TextureRegistry.getTexture("minecraft:particle/splash_rain_1"),
+            TextureRegistry.getTexture("minecraft:particle/splash_rain_2"),
+            TextureRegistry.getTexture("minecraft:particle/splash_rain_3"),
+    };
+    public static final @NotNull IconCoordinate @NotNull [] ICON_SPLASH_RAIN_BLOOD = new IconCoordinate[] {
+            TextureRegistry.getTexture("minecraft:particle/splash_rain_blood_0"),
+            TextureRegistry.getTexture("minecraft:particle/splash_rain_blood_1"),
+            TextureRegistry.getTexture("minecraft:particle/splash_rain_blood_2"),
+            TextureRegistry.getTexture("minecraft:particle/splash_rain_blood_3"),
+    };
+
+    public static final @NotNull IconCoordinate ICON_ACID_POPPING = TextureRegistry.getTexture("minecraft:particle/acid_boiling_pop");
+    public static final @NotNull IconCoordinate ICON_ACID_BOILING = TextureRegistry.getTexture("minecraft:particle/acid_boiling");
+    public static final @NotNull IconCoordinate ICON_BUBBLE = TextureRegistry.getTexture("minecraft:particle/bubble");
+    public static final @NotNull IconCoordinate ICON_BUBBLE_LAVA = TextureRegistry.getTexture("minecraft:particle/bubble_lava");
+    public static final @NotNull IconCoordinate ICON_BUBBLE_BOILING = TextureRegistry.getTexture("minecraft:particle/bubble_boiling");
+    public static final @NotNull IconCoordinate ICON_BUBBLE_BOILING_POP = TextureRegistry.getTexture("minecraft:particle/bubble_boiling_pop");
+
+    public static final @NotNull IconCoordinate ICON_FIREFLY = TextureRegistry.getTexture("minecraft:particle/firefly");
+    public static final @NotNull IconCoordinate ICON_HEART = TextureRegistry.getTexture("minecraft:particle/heart");
+    public static final @NotNull IconCoordinate ICON_NOTE = TextureRegistry.getTexture("minecraft:particle/note");
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleVentSmoke.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleVentSmoke.java
index 5d0b75f4d..7f4b9229e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleVentSmoke.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleVentSmoke.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.tessellator.TessellatorParticle;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
@@ -44,20 +44,24 @@ public class ParticleVentSmoke extends Particle {
 
     @Override
     public void tick() {
+        int cX = MathHelper.floor(this.x);
+        int cY = MathHelper.floor(this.y);
+        int cZ = MathHelper.floor(this.z);
+
+        if (cX != this.bX || cY != this.bY || cZ != this.bZ) {
+            this.bX = cX;
+            this.bY = cY;
+            this.bZ = cZ;
+            this.cachedLightmapCoord = calcLightIndex(1f);
+        }
+        
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
         if (this.age++ >= this.lifetime) {
             this.remove();
         }
-        int val = (14 - ((this.age * 14) / this.lifetime));
-        if(val > 7)
-            val = 7;
-        if (val >= 0) {
-            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
-        } else {
-            this.tex = null;
-        }
+        this.tex = ParticleTextureCache.getPuffStage(this.age, this.lifetime);
         this.yd += 0.004D;
         this.move(this.xd, this.yd, this.zd);
         if (this.y == this.yo) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleWaterDrop.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleWaterDrop.java
index 7303d06d1..7120f132e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleWaterDrop.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleWaterDrop.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.MathHelper;
@@ -18,13 +17,14 @@ public class ParticleWaterDrop extends Particle {
         this.rCol = 1.0F;
         this.gCol = 1.0F;
         this.bCol = 1.0F;
-        this.tex = TextureRegistry.getTexture((dimension == Dimension.NETHER ? "minecraft:particle/splash_rain_blood_" : "minecraft:particle/splash_rain_") + random.nextInt(4));
+        this.tex = (dimension == Dimension.NETHER ? ParticleTextureCache.ICON_SPLASH_RAIN_BLOOD : ParticleTextureCache.ICON_SPLASH_RAIN)[random.nextInt(4)];
         this.gravity = 0.06F;
         this.lifetime = (int) (8D / (Math.random() * 0.8D + 0.2D));
     }
 
     @Override
     public void tick() {
+        class Cache {private static final @NotNull TilePos queryPos = new TilePos(); }
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
@@ -43,10 +43,10 @@ public class ParticleWaterDrop extends Particle {
             this.xd *= 0.7D;
             this.zd *= 0.7D;
         }
-        TilePos tilePos = new TilePos(this.x, this.y, this.z);
-        Material m = this.world.getBlockMaterial(tilePos);
+        Cache.queryPos.set(this.x, this.y, this.z);
+        Material m = this.world.getBlockMaterial(Cache.queryPos);
         if (m.isLiquid() || m.isSolid()) {
-            double y0 = (MathHelper.floor(this.y) + 1) - BlockLogicFluid.getHeight(this.world.getBlockData(tilePos));
+            double y0 = (MathHelper.floor(this.y) + 1) - BlockLogicFluid.getHeight(this.world.getBlockData(Cache.queryPos));
             if (this.y < y0) {
                 remove();
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
index b9f29d5ec..c3eb22959 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
@@ -16,7 +16,6 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCache;
-import net.minecraft.core.world.particle.ParticleEmitterRange;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -83,14 +82,6 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
                     for (pos.x = this.min.x; pos.x < this.max.x; pos.x++) {
                         final @NotNull Block<?> block = chunkCache.getBlockType(pos);
 
-                        if (renderPass == 0) {
-                            ParticleEmitterRange type = block.getLogic().getParticleEmitterRange();
-
-                            if (type != null) {
-                                this.getWorld().particleEmitters.add(new TilePos(pos), type);
-                            }
-                        }
-
                         if (!hasStartedDrawing) {
                             hasStartedDrawing = true;
                             TESSELLATOR.startDrawingQuads();
diff --git a/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java b/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
index 305026db1..dff1ec2ba 100644
--- a/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
+++ b/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
@@ -27,7 +27,7 @@ public class OpenGLLoggerCallback implements GLDebugMessageCallbackI {
                     getSourceName(source),
                     getTypeName(type),
                     getIdName(id),
-                    msg, new RuntimeException()
+                    msg, new RuntimeException("")
                 );
                 break;
             }
@@ -37,7 +37,7 @@ public class OpenGLLoggerCallback implements GLDebugMessageCallbackI {
                     getSourceName(source),
                     getTypeName(type),
                     getIdName(id),
-                    msg, new RuntimeException()
+                    msg, new RuntimeException("")
                 );
                 break;
             }
@@ -47,7 +47,7 @@ public class OpenGLLoggerCallback implements GLDebugMessageCallbackI {
                     getSourceName(source),
                     getTypeName(type),
                     getIdName(id),
-                    msg, new RuntimeException()
+                    msg, new RuntimeException("")
                 );
                 break;
             }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index 59e45954c..d11407054 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -8,10 +8,12 @@ import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
 import net.minecraft.client.world.chunk.provider.ChunkProviderThreadedClient;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkLoader;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePos;
@@ -48,6 +50,27 @@ public class WorldClient extends World {
         this.mc = parent.mc;
     }
 
+    @Override
+    protected void updateTileEntities() {
+        final var particleRenderDistance = GameSettings.PARTICLE_RENDER_DISTANCE.value * 16;
+        for (int i = this.tileEntityList.size() - 1; i >= 0; i--) {
+            final TileEntity tileEntity = this.tileEntityList.get(i);
+            if (!tileEntity.isInvalid() && this.isBlockLoaded(tileEntity.tilePos)) {
+                tileEntity.tick();
+                if (tileEntity instanceof TileEntity.AnimationTicking animated) {
+                    final double dx = tileEntity.tilePos.x - this.mc.thePlayer.x;
+                    final double dy = tileEntity.tilePos.y - this.mc.thePlayer.y;
+                    final double dz = tileEntity.tilePos.z - this.mc.thePlayer.z;
+                    animated.animationTick(particleRenderDistance, dx * dx + dy * dy + dz * dz);
+                }
+            }
+            if (tileEntity.isInvalid()) {
+                this.tileEntityList.remove(i);
+                this.getChunk(tileEntity.tilePos).removeTileEntity(tileEntity);
+            }
+        }
+    }
+
     @Override
     public void setLightningFlicker(final int lightningFlicker) {
         this.lightningFlicker = lightningFlicker;
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
index f18cc4cca..d2f6ae367 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
@@ -14,15 +14,13 @@ import org.jetbrains.annotations.Nullable;
 import java.util.*;
 
 public class ChunkProviderClient implements ChunkProvider {
-    protected static final @NotNull ChunkPos MIN_POS = new ChunkPos(Integer.MIN_VALUE, Integer.MIN_VALUE);
-
     private final @NotNull Chunk blankChunk;
     private final @NotNull Map<ChunkPos, Chunk> chunkMapping = new Object2ObjectOpenHashMap<>();
     private final @NotNull World world;
 
 
     protected @NotNull Chunk lastQueriedChunk;
-    protected @NotNull ChunkPos lastQueriedChunkPos = MIN_POS;
+    protected @NotNull ChunkPos lastQueriedChunkPos = new ChunkPos(Integer.MIN_VALUE, Integer.MIN_VALUE);
 
     public ChunkProviderClient(@NotNull World world) {
         this.blankChunk = new EmptyChunk(world, new ChunkPos(0, 0));
@@ -51,6 +49,10 @@ public class ChunkProviderClient implements ChunkProvider {
             chunk.onUnload();
         }
         this.chunkMapping.remove(chunkPos);
+        if (chunkPos.equals(this.lastQueriedChunkPos)) {
+            this.lastQueriedChunkPos.set(Integer.MIN_VALUE, Integer.MIN_VALUE);
+            this.lastQueriedChunk = this.blankChunk;
+        }
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
index 2f903e673..d7ec1a765 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
@@ -115,7 +115,7 @@ public class StatsCounter {
 	}
 
 	public boolean canUnlock(Achievement achievement) {
-		return achievement.parent == null || isUnlocked(achievement.parent);
+		return achievement.parent == null || isUnlocked(achievement.parent) || isUnlocked(achievement);
 	}
 
 	public int readStat(@Nullable Stat stat) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index cd6a1ac78..3880df35b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -589,8 +589,8 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public boolean isEquivalent(final @NotNull World world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos) {
-        return this.logic.isEquivalent(world, thisPos, thatPos);
+    public boolean isEquivalent(final @NotNull WorldSource world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos, final @NotNull Block<?> thatBlock) {
+        return this.logic.isEquivalent(world, thisPos, thatPos, thatBlock);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
index 241264472..a259c11c0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
@@ -390,7 +390,11 @@ interface BlockInterface {
         return this.isClimbable(world, new TilePos(x, y, z));
     }
 
-    boolean isEquivalent(final @NotNull World world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos);
+    boolean isEquivalent(final @NotNull WorldSource world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos, final @NotNull Block<?> thatBlock);
+    
+    default boolean isEquivalent(final @NotNull WorldSource world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos) {
+        return this.isEquivalent(world, thisPos, thatPos, world.getBlockType(thatPos));
+    }
 
     @Deprecated
     default boolean isEquivalent(final @NotNull World world, final int thisX, final int thisY, final int thisZ, final int thatX, final int thatY, final int thatZ) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index 668fdc792..e46945dd1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -28,7 +28,6 @@ import net.minecraft.core.util.phys.BoundingVolume;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.particle.ParticleEmitterRange;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -211,18 +210,12 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
 
     @Override
     public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        ParticleEmitterRange t = this.getParticleEmitterRange();
-        if (t != null) {
-            world.particleEmitters.add(tilePos, t);
-        }
+
     }
 
     @Override
     public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
-        ParticleEmitterRange t = this.getParticleEmitterRange();
-        if (t != null) {
-            world.particleEmitters.remove(tilePos);
-        }
+
     }
 
     @Override
@@ -244,11 +237,6 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     @Override
     public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
         this.onPlacedOnSide(world, tilePos, side, xHit, yHit);
-
-        ParticleEmitterRange t = this.getParticleEmitterRange();
-        if (t != null) {
-            world.particleEmitters.add(tilePos, t);
-        }
     }
 
     @Override
@@ -514,54 +502,84 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
         return false;
     }
 
-    /**
-     * Metadata compared by the matcher. Override to ignore orientation while keeping visual state (e.g. powered).
-     */
-    protected int getMatcherEquivalenceData(final int data) {
-        return data;
+    @Override
+    public boolean isEquivalent(final @NotNull WorldSource world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos, final @NotNull Block<?> thatBlock) {
+        return
+            this.isEquivalentBlockForMatcher(thatBlock) &&
+            this.isEquivalentDataForMatcher(world, thisPos, thatPos) &&
+            this.isEquivalentEntityForMatcher(world, thisPos, thatPos);
     }
 
-    /**
-     * Whether another block counts as the same type for matcher comparison (e.g. on/off variants).
-     */
-    protected boolean isSameBlockForMatcher(final @NotNull Block<?> other) {
-        return this.block == other;
+    // prevents accidental mis-impl
+    @Override
+    public final boolean isEquivalent(final @NotNull WorldSource world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos) {
+        return BlockInterface.super.isEquivalent(world, thisPos, thatPos);
     }
 
-    public record MatcherSnapshot(@NotNull Block<?> block, int meta, @NotNull BlockLogic logic) {}
-
-    /**
-     * Resolves the block/meta/logic at this position for matcher comparison.
-     * <p>
-     * The default implementation returns the block actually stored in the world. Blocks
-     * that visually stand in for another block (e.g. the moving piston, which carries
-     * its real contents in the tile entity) should override this to delegate to that block.
-     */
-    public @NotNull MatcherSnapshot resolveForMatcher(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        final @NotNull Block<?> block = world.getBlockType(tilePos);
-        return new MatcherSnapshot(block, world.getBlockData(tilePos), block.getLogic());
+    protected boolean isEquivalentBlockForMatcher(final @NotNull Block<?> other) {
+        return this.block == other;
     }
 
-    public static @NotNull MatcherSnapshot resolveMatcherBlock(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        return world.getBlockType(tilePos).getLogic().resolveForMatcher(world, tilePos);
+    protected final boolean isEquivalentDataForMatcher(
+        @NotNull WorldSource world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos
+    ) {
+        return this.matcherDataEquivImpl == null || this.matcherDataEquivImpl.isEquivalentDataForMatcherImpl(
+            world.getBlockData(thisPos),
+            world.getBlockData(thatPos)
+        );
     }
 
-    public static boolean areBlocksEquivalentForMatcher(
-        final @NotNull World world,
-        final @NotNull TilePosc posA,
-        final @NotNull TilePosc posB
+    protected final boolean isEquivalentEntityForMatcher(
+        @NotNull WorldSource world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos
     ) {
-        final @NotNull MatcherSnapshot a = resolveMatcherBlock(world, posA);
-        final @NotNull MatcherSnapshot b = resolveMatcherBlock(world, posB);
-        if (!a.logic().isSameBlockForMatcher(b.block()) || !b.logic().isSameBlockForMatcher(a.block())) {
-            return false;
+        if (this.matcherEntityEquivImpl == null) return true;
+
+        final TileEntity a, b;
+        if (this.matcherEntityEquivImpl.isEntityRequiredForMatching()) {
+            a = world.getTileEntity(thisPos);
+            if (a == null) return false;
+
+            final Class<?> entityClass = this.matcherEntityEquivImpl.getEntityEquivalencyClass();
+            if (!entityClass.isInstance(a)) return false;
+
+            b = world.getTileEntity(thatPos);
+            if (b == null || !entityClass.isInstance(b)) return false;
+        }
+        else {
+            a = world.getTileEntity(thisPos);
+            b = world.getTileEntity(thatPos);
         }
-        return a.logic().getMatcherEquivalenceData(a.meta()) == b.logic().getMatcherEquivalenceData(b.meta());
+        return this.matcherEntityEquivImpl.isEquivalentEntityForMatcherImpl(a, b);
     }
 
-    @Override
-    public boolean isEquivalent(final @NotNull World world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos) {
-        return areBlocksEquivalentForMatcher(world, thisPos, thatPos);
+    private final @Nullable MatcherDataEquivalency matcherDataEquivImpl =
+        (this instanceof MatcherDataEquivalency impl) ? impl : null;
+
+    public interface MatcherDataEquivalency {
+        default boolean isEquivalentDataForMatcherImpl(final int thisData, final int thatData) {
+            return thisData == thatData;
+        }
+
+        public interface Masked extends MatcherDataEquivalency {
+            int getMatcherDataEquivalencyMask();
+
+            @Override
+            default boolean isEquivalentDataForMatcherImpl(int thisData, int thatData) {
+                final int mask = getMatcherDataEquivalencyMask();
+                return (thisData & mask) == (thatData & mask);
+            }
+        }
+    }
+
+    @SuppressWarnings("unchecked")
+    private final @Nullable MatcherEntityEquivalency<TileEntity> matcherEntityEquivImpl =
+        (this instanceof MatcherEntityEquivalency impl) ? (MatcherEntityEquivalency<TileEntity>)impl : null;
+
+    public interface MatcherEntityEquivalency<TE extends TileEntity> {
+        default boolean isEntityRequiredForMatching() { return true; }
+        @NotNull Class<TE> getEntityEquivalencyClass();
+
+        boolean isEquivalentEntityForMatcherImpl(final TE thisEntity, final TE thatEntity);
     }
 
     @Override
@@ -578,8 +596,4 @@ public class BlockLogic implements BlockInterface, IItemConvertible {
     public @NotNull ItemStack getDefaultStack() {
         return this.block.getDefaultStack();
     }
-
-    public @Nullable ParticleEmitterRange getParticleEmitterRange() {
-        return null; // null by default, 16 block radius
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
index c82bba4ed..9779a578f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
@@ -24,12 +24,14 @@ import java.util.Random;
 import static net.minecraft.core.block.BlockLogicConduit.packEventConduitData;
 
 public class BlockLogicActivator
-    extends BlockLogicVeryRotatable {
+    extends BlockLogicVeryRotatable
+    implements BlockLogic.MatcherDataEquivalency.Masked
+{
     public static final int MASK_POWERED = 0b0000_1000;
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & MASK_POWERED;
+    public int getMatcherDataEquivalencyMask() {
+        return MASK_POWERED;
     }
 
     public BlockLogicActivator(final @NotNull Block<?> block) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
index f381b4741..f8fe18d53 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
@@ -121,9 +121,4 @@ public class BlockLogicAir
     public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
-
-    @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        return false;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
index 6c4214482..ec2265d18 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
@@ -17,11 +17,6 @@ public class BlockLogicAxisAligned
         super(block, material);
     }
 
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & ~MASK_DIRECTION;
-    }
-
     @Override
     public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
         final @NotNull Axis axis = mob.getPlacementDirection(side, PlacementMode.SIDE).axis();
@@ -47,5 +42,4 @@ public class BlockLogicAxisAligned
         if (meta == 1) return Axis.Z;
         return Axis.Y;
     }
-
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
index 980dada5f..121397c0a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
@@ -26,7 +26,10 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Objects;
 
-public class BlockLogicBasket extends BlockLogic {
+public class BlockLogicBasket
+extends BlockLogic
+implements BlockLogic.MatcherEntityEquivalency<TileEntityBasket>
+{
     protected BlockLogicBasket(final @NotNull Block<?> block, final @NotNull Material material) {
         super(block, material);
         block.withEntity(TileEntityBasket::new);
@@ -86,12 +89,14 @@ public class BlockLogicBasket extends BlockLogic {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        assert world.getBlockType(thisPos) == this.block;
-        if (world.getBlockType(thatPos) != this.block) return false;
-        if (!(world.getTileEntity(thisPos) instanceof TileEntityBasket thisBasket) ||
-            !(world.getTileEntity(thatPos) instanceof TileEntityBasket thatBasket))
-            return false;
+    public @NotNull Class<TileEntityBasket> getEntityEquivalencyClass() {
+        return TileEntityBasket.class;
+    }
+
+    @Override
+    public boolean isEquivalentEntityForMatcherImpl(
+        @NotNull TileEntityBasket thisBasket, @NotNull TileEntityBasket thatBasket
+    ) {
         return getFillLevel(thisBasket) == getFillLevel(thatBasket);
     }
 
